Attribute VB_Name = "basINI"
'original Code aus Multifunktions-DLL von Wolfgang Erhardt.

Option Explicit

Private Declare Function WritePrivateProfileString Lib "kernel32" Alias "WritePrivateProfileStringA" (ByVal lpApplicationName As String, ByVal lpKeyName As Any, ByVal lpString As Any, ByVal lpFileName As String) As Long
Private Declare Function GetPrivateProfileString Lib "kernel32" Alias "GetPrivateProfileStringA" (ByVal lpApplicationName As String, ByVal lpKeyName As Any, ByVal lpDefault As String, ByVal lpReturnedString As String, ByVal nSize As Long, ByVal lpFileName As String) As Long
Private Declare Function DeletePrivateProfileSection Lib "kernel32" Alias "WritePrivateProfileStringA" (ByVal Section As String, ByVal NoKey As Long, ByVal NoSetting As Long, ByVal FileName As String) As Long
Private Declare Function GetPrivateProfileSection Lib "kernel32" Alias "GetPrivateProfileSectionA" (ByVal lpAppName As String, ByVal lpReturnedString As String, ByVal nSize As Long, ByVal lpFileName As String) As Long
Private Declare Function GetPrivateProfileSectionNames Lib "kernel32.dll" Alias "GetPrivateProfileSectionNamesA" (ByVal lpszReturnBuffer As String, ByVal nSize As Long, ByVal lpFileName As String) As Long

'Public Type SectionResult
'    sValue      As String
'    sAbschnitt  As String
'End Type

Private mc_pAbschnitt   As Collection
Private mc_pValue       As Collection

Public Function Read_INI(ByVal iniPath As String, _
                         ByVal Section As String, _
                         ByVal Abschnitt As String, _
                         Optional sDefault As String = "") As String
On Error GoTo z
Dim RetStr As String

RetStr = String(255, Chr$(0))

Read_INI = Left$(RetStr, GetPrivateProfileString(Section, _
                                         Abschnitt, sDefault, _
                                         RetStr, Len(RetStr), _
                                         iniPath))

Exit Function
z:
MsgBox Err.Number & vbCrLf & Err.Description
End Function

Public Function Write_INI(ByVal iniPath As String, _
                          ByVal Section As String, _
                          ByVal Abschnitt As String, _
                          ByVal Value As String) As Boolean
    
    If Value = "" Then Value = Space(1)
    
    If WritePrivateProfileString(Section, Abschnitt, Value, iniPath) Then
        Write_INI = True
    End If
End Function

Public Sub Remove_Section(ByVal iniPath As String, ByVal Section As String)
    Call DeletePrivateProfileSection(Section, 0, 0, iniPath)
End Sub

Public Function WriteArray(ByVal iniPath As String, _
                           ByVal Section As String, _
                           sArray() As String) As Boolean
    Dim P As Long
        
    On Local Error GoTo Quit

    Call Remove_Section(iniPath, Section)
    
    For P = LBound(sArray) To UBound(sArray)
        If WritePrivateProfileString(Section, CStr(P), CStr(sArray(P)), iniPath) = 0 Then
            Exit Function
        End If
    Next P

    WriteArray = True
    
Quit:
End Function

Public Sub Del_Collections()
    'Collections lschen und neu initialisieren
    Set mc_pAbschnitt = New Collection
    Set mc_pValue = New Collection
End Sub

Public Sub INIReadSection(ByVal iniPath As String, _
                          ByVal Section As String)
                            
    Dim Result As Long, L As Long, P As Long, z As Long, X As Long
    Dim Buffer As String, B() As String, C() As String
        
    Buffer = Space(32767)
    Result = GetPrivateProfileSection(Section, Buffer, Len(Buffer), iniPath)
    
    Buffer = Left$(Buffer, Result)
    
    If Buffer <> "" Then
        L = 1
        z = 0
        
        Do While L < Result
            P = InStr(L, Buffer, Chr$(0))
            If P = 0 Then Exit Do
            
            ReDim Preserve B(z)
            
            B(z) = Mid$(Buffer, L, P - L)
            
            z = z + 1
            L = P + 1
        Loop
    Else
        Exit Sub
    End If

    For P = 0 To UBound(B)
        C = Split(B(P), "=")
        mc_pAbschnitt.Add Trim(C(0)), CStr(mc_pAbschnitt.Count)
        mc_pValue.Add Trim(C(1)), CStr(mc_pValue.Count)
    Next P
End Sub

Public Property Get scol_Abschnitt(ByVal iIndex As String) As String
On Error GoTo z
scol_Abschnitt = mc_pAbschnitt(iIndex)
Exit Property
z:
scol_Abschnitt = ""
End Property

Public Property Get scol_Value(ByVal iIndex As String) As String
On Error GoTo z
scol_Value = mc_pValue(iIndex)

Exit Property
z:
scol_Value = ""
End Property

'Count der Collection ausgeben
Public Property Get lCount() As Long
On Error GoTo z
lCount = mc_pAbschnitt.Count

Exit Property
z:
lCount = 0
End Property

Public Function INISectionEnum(ByVal iniPath As String) As String()
Dim Result&, Buffer$, X&, Y&, Pos&
Dim lp_sTmp() As String

On Error GoTo z
X = 256
ReDim lp_sTmp(0)

Do
    Buffer = String$(X, Chr$(0))
    Result = GetPrivateProfileSectionNames(Buffer, X _
                                           , iniPath)
    X = X + 256
Loop While (Result + 2 = X - 256)

If Result Then
    Pos = 1
    Y = 1
    Do While Y < Result
        Pos = InStr(Y, Buffer, Chr$(0))
        'List1.AddItem Mid$(Buffer, y, pos - y)
        'Debug.Print Mid$(Buffer, y, Pos - y)
        lp_sTmp(UBound(lp_sTmp)) = Mid$(Buffer, Y, Pos - Y)
        ReDim Preserve lp_sTmp(UBound(lp_sTmp) + 1)
        Y = Pos + 1
    Loop
End If

INISectionEnum = lp_sTmp
Exit Function
z:
'INISectionEnum = False
Debug.Print Err.Number
Debug.Print Err.Description
End Function

