VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "cDrive"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit
'Deklaration:
Private Const DRIVE_CDROM As Long = 5
Private Const DRIVE_FIXED As Long = 3
Private Const DRIVE_RAMDISK As Long = 6
Private Const DRIVE_REMOTE As Long = 4
Private Const DRIVE_REMOVABLE As Long = 2

'Deklaration:

'Dateien/Ordner suchen
Private Declare Function FindFirstFile Lib "kernel32" _
        Alias "FindFirstFileA" (ByVal lpFileName As String, _
        lpFindFileData As WIN32_FIND_DATA) As Long
        
Private Declare Function FindNextFile Lib "kernel32" _
        Alias "FindNextFileA" (ByVal hFindFile As Long, _
        lpFindFileData As WIN32_FIND_DATA) As Long
        
Private Declare Function FindClose Lib "kernel32" (ByVal _
        hFindFile As Long) As Long


Private Type FILETIME
    dwLowDateTime As Long
    dwHighDateTime As Long
End Type

Const MAX_PATH                      As Long = 259&
Const FILE_ATTRIBUTE_ARCHIVE        As Long = &H20&
Const FILE_ATTRIBUTE_COMPRESSED     As Long = &H800&
Const FILE_ATTRIBUTE_DIRECTORY      As Long = &H10&
Const FILE_ATTRIBUTE_HIDDEN         As Long = &H2&
Const FILE_ATTRIBUTE_NORMAL         As Long = &H80&
Const FILE_ATTRIBUTE_READONLY       As Long = &H1&
Const FILE_ATTRIBUTE_SYSTEM         As Long = &H4&
Const FILE_ATTRIBUTE_TEMPORARY      As Long = &H100&

Private Type WIN32_FIND_DATA
    dwFileAttributes As Long
    ftCreationTime As FILETIME
    ftLastAccessTime As FILETIME
    ftLastWriteTime As FILETIME
    nFileSizeHigh As Long
    nFileSizeLow As Long
    dwReserved0 As Long
    dwReserved1 As Long
    cFileName As String * MAX_PATH
    cAlternate As String * 14
End Type


Private Declare Function ShellExecute Lib "shell32.dll" Alias "ShellExecuteA" ( _
     ByVal hwnd As Long, _
     ByVal lpOperation As String, _
     ByVal lpFile As String, _
     ByVal lpParameters As String, _
     ByVal lpDirectory As String, _
     ByVal nShowCmd As Long) As Long

Private Declare Function GetDriveType Lib "kernel32" Alias "GetDriveTypeA" ( _
    ByVal nDrive As String) As Long

Private Declare Function GetLogicalDriveStrings Lib "kernel32" _
    Alias "GetLogicalDriveStringsA" (ByVal nBufferLength As Long, _
    ByVal lpBuffer As String) As Long
    
Private Declare Function GetVolumeInformation Lib "kernel32" _
        Alias "GetVolumeInformationA" (ByVal lpRootPathName _
        As String, ByVal lpVolumeNameBuffer As String, ByVal _
        nVolumeNameSize As Long, lpVolumeSerialNumber As Long, _
        lpMaximumComponentLength As Long, lpFileSystemFlags _
        As Long, ByVal lpFileSystemNameBuffer As String, ByVal _
        nFileSystemNameSize As Long) As Long

Private Declare Function SetVolumeLabel Lib "kernel32" _
        Alias "SetVolumeLabelA" (ByVal lpRootPathName _
        As String, ByVal lpVolumeName As String) As Long

'freien Speicher ermitteln
Private Type ULARGE_INTEGER
    LowPart As Long
    HighPart As Long
End Type

Private Declare Function GetDiskFreeSpaceEx Lib "kernel32" _
        Alias "GetDiskFreeSpaceExA" (ByVal lpPathname As _
        String, ByVal UserFree As Any, ByVal TotalSize As _
        Any, ByVal TotalFree As Any) As Long

'####################################################
'#                   Attribute                      #
'####################################################

Private mc_DriveCol_Type    As Collection
Private mc_DriveCol_Letter  As Collection

'gefundene Laufwerke Infos ablegen
Private mc_USBFile              As Collection
Private Const pc_NOFOUND        As Integer = -2

'wenn mehr als ein Wechseldatentrger gefunden wurde
'Dialog zur Auswahl der gefunden Datentrgern wird geffnet
'momentan nur ein Datentrger berwachbar
Private Const pc_CHOOSE_DRIVE   As Integer = -1

Private mp_dTotSize As Double
Private mp_dTotFree As Double

'Standard Pfad
Private mp_Pfad As String
Private mp_bUse As Boolean

'FileSystem
Private mp_FileS As String

'####################################################
'#                   Methoden                       #
'####################################################

'Bezeichnung:   mp_GetDiskSpace
'Funktion   :   liest freien Speicherplatz
Public Sub mp_GetDiskSpace(ByVal sDrive As String)
Dim UsrFree As String * 8
Dim TotSize As String * 8
Dim TotFree As String * 8

Call GetDiskFreeSpaceEx(sDrive, UsrFree, TotSize, TotFree)
 
mp_dTotSize = CvStr(TotSize)
mp_dTotFree = CvStr(TotFree)
End Sub

'Bezeichnung:   CvStr
'Funktion   :   wandelt Stringwerte in Double um
Private Function CvStr(s) As Double
  Dim i%, X As Double, P As Double
  
   P = 1
   For i = 1 To Len(s)
     X = X + Asc(Mid(s, i, 1)) * P
     P = P * 256
   Next i
   CvStr = X
End Function

'Bezeichnung:   TotalSpace
'Funktion   :   gibt Speicherplatz von ausgelesenem Laufwerk aus
Public Property Get TotalSpace() As Double
TotalSpace = mp_dTotSize
End Property

'Bezeichnung:   TotalSpace
'Funktion   :   gibt noch freien Speicherplatz von ausgelesenem Laufwerk aus
Public Property Get TotalFreeSpace() As Double
TotalFreeSpace = mp_dTotFree
End Property

'Bezeichnung:   mp_SetDriveName
'Funktion   :   setzt Laufwerksbezeichnung
Public Function mp_SetDriveName(ByVal Drive$, ByVal Name$)
  'Name = Left$(Name, 11) & Chr$(0)
  Call SetVolumeLabel(Drive, Name)
End Function

'Bezeichnung:   mp_GetDriveTyps
'Funktion   :   liest Laufwerkstyp und -Buchstabe aus
Public Sub mp_GetDriveTyps()
    Dim lngErgebnis As Long
    Dim lngPuffer As Long
    Dim lngTyp As Long
    Dim X As Long

    Dim strBezeichnung As String
    Dim strLaufwerk As String
    Dim strLaufwerke As String
    Dim strPuffer As String

    'List1.Clear

    'Speicherplatz reservieren
    lngPuffer = 64
    strPuffer = Space$(lngPuffer)

    'Laufwerksbuchstaben ermitteln
    lngErgebnis = GetLogicalDriveStrings(lngPuffer, strPuffer)
    strLaufwerke = Left$(strPuffer, lngErgebnis)
    
    'Collections lschen und neu initialisieren
    Set mc_DriveCol_Type = New Collection
    Set mc_DriveCol_Letter = New Collection
    
    Do While X < Len(strPuffer)
        X = InStr(strPuffer, vbNullChar)

        If X <> 0 Then
            strLaufwerk = Left$(strPuffer, X)
            strPuffer = Mid$(strPuffer, X + 1, Len(strPuffer))

            'Laufwerkstyp ermitteln
            lngTyp = GetDriveType(strLaufwerk)
            If lngTyp <> 1 Then
                Select Case lngTyp
'                    Case DRIVE_CDROM
'                        strBezeichnung = "CD-ROM"
'                    Case DRIVE_FIXED
'                        strBezeichnung = "Festplatte"
'                    Case DRIVE_RAMDISK
'                        strBezeichnung = "RAM-Disk"
'                    Case DRIVE_REMOTE
'                        strBezeichnung = "Netzlaufwerk"
                    'Case DRIVE_REMOTE
                    Case DRIVE_REMOVABLE
                        strBezeichnung = "Wechseldatentrger"
                        strLaufwerk = UCase(Mid$(strLaufwerk, 1, 2))
                        
                        If strLaufwerk <> "A:" Then
                            'Laufwerkstyp und -buchstaben Property zuweisen

                            p_GetDriveTyps(CStr(mc_DriveCol_Type.Count)) = strBezeichnung   '& vbTab & GetDriveName(strLaufwerk)
                            p_GetDriveLetters(CStr(mc_DriveCol_Letter.Count)) = strLaufwerk
                        End If
                End Select
            End If
        Else
            Exit Do
        End If
    Loop
mp_Check4USB_File
End Sub

'Bezeichnung:   mp_GetDriveName
'Funktion   :   liest Laufwerksbezeichnung aus
Public Function mp_GetDriveName(ByVal Drive$) As String
Dim Result&, SerN&, PathL&, flags&
Dim VolN As String * 256
Dim FileS As String * 256

Result = GetVolumeInformation(Drive, VolN, 256, SerN, _
                              PathL, flags, FileS, 256)
                             
mp_FileS = FileS
mp_GetDriveName = Left$(VolN, InStr(VolN, Chr$(0)) - 1)
End Function

'Bezeichnung:   mp_Check4USB_File
'Funktion   :   berprft ob USB.ini File auf angegebenem Laufwerk vorhanden ist.
Private Function mp_Check4USB_File()
Dim i       As Integer
Dim sPath   As String
Dim sSecs() As String

'Collection lschen und neu initialisieren
Set mc_USBFile = New Collection
'lscht die Collections mit ergebnissen der Ini-File vom USB Stick

If p_GetDL_Count > 1 Then
    p_SetUSBInfos(CStr(p_USBInfosCount)) = pc_CHOOSE_DRIVE
    frmAuswahl.Show vbModeless, frmMain
    Exit Function
    
ElseIf p_GetDL_Count < 1 Then
    p_SetUSBInfos(CStr(p_USBInfosCount)) = pc_NOFOUND
    objTray.TrayIcon_Icon = LoadResPicture(ICON_NO_USB_STICK, vbResIcon)
    Exit Function
    
Else
    
    objTray.TrayIcon_Icon = LoadResPicture(ICON_USB_STICK_FOUND, vbResIcon)
    If mp_Check4FileExist(p_GetDriveLetters(0) & "USB.ini") Then
        Del_Collections
        
        sPath = p_GetDriveLetters(0) & "USB.ini"
        sSecs = INISectionEnum(sPath)
        
        For i = 0 To UBound(sSecs) - 1
            'Debug.Print sSecs(i)
            INIReadSection sPath, sSecs(i)
        Next
        
        For i = 0 To lCount - 1 Step 2
            'Debug.Print scol_Abschnitt(CStr(i)) & " = " & scol_Value(CStr(i))
            p_SetUSBInfos(CStr(i)) = scol_Abschnitt(CStr(i))
            p_SetUSBInfos(CStr(i + 1)) = scol_Value(CStr(i))
            'sSecsVal = INIReadSection("E:\USB.ini", sSecs(i))
        Next
    End If
End If
End Function

'Bezeichnung:   mp_Check4Exist
'Funktion   :   berprft ob bergebene File oder Ordner vorhanden ist
Private Function mp_Check4FileExist(ByVal sPath As String) As Boolean
On Error GoTo z
Select Case GetAttr(sPath)
                
    Case vbDirectory
        If Dir$(sPath, vbDirectory) = "" Then
            mp_Check4FileExist = False
        Else
            mp_Check4FileExist = True
        End If
        
    Case vbArchive
        If Dir$(sPath, vbArchive) = "" Then
            mp_Check4FileExist = False
        Else
            mp_Check4FileExist = True
        End If
    
    Case Else
            mp_Check4FileExist = False
        
End Select
Exit Function
z:
If Err.Number = 53 Then mp_Check4FileExist = False
End Function

'Bezeichnung:   OpenDir
'Funktion   :   ffnet bergebenen Pfad
Public Sub OpenDir(ByVal sPath As String)
If mp_Check4FileExist(sPath) Then ShellExecute frmMain.hwnd, "open", sPath, vbNullString, vbNullString, 1
End Sub

'Bezeichnung:   RemoveUSB_Info
'Funktion   :   entfernt Informationen ber USB-Stick wenn dieser entfernt wird
Public Sub RemoveUSB_Info()
With frmMain
    .txtOpenPath.Text = ""
    objDrive.mp_StandardPfad = ""
    .txtFAT.Text = ""
    .txtDT_Cap.Text = ""
    .lblHDFree.Caption = ""
    .lblHDSize.Caption = ""
    .lblHDUsed.Caption = ""
    .Picture1.Cls
    .cmdChoose.Enabled = False
End With

Del_Collections
Set mc_USBFile = New Collection
Set mc_DriveCol_Letter = New Collection
Set mc_DriveCol_Type = New Collection

End Sub

Public Sub ChooseUSB_Info(Optional sItem As String)
'objDrive.mp_GetDriveTyps

If sItem = "" Or objDrive.p_GetDL_Count > 1 Then
    If objDrive.p_GetUSBInfos(objDrive.p_USBInfosCount - 1) = CStr(pc_CHOOSE_DRIVE) Then
        objDrive.p_Del_DriveLetters
        objDrive.p_GetDriveLetters("0") = sItem
        SetUSB_Info
        Exit Sub
        
    ElseIf objDrive.p_GetUSBInfos(objDrive.p_USBInfosCount - 1) = CStr(pc_NOFOUND) Then
        MsgBox "Kein Datentrger gefunden", vbInformation, frmMain.Caption
        RemoveUSB_Info
        Exit Sub
'    Else
'        sItem = objDrive.p_GetDriveLetters(1)
'        'sItem = objDrive.mp_GetDriveName(objDrive.p_GetDriveLetters(1))
'        frmMain.txtOpenPath.Text = scol_Value("3")
'        frmMain.txtDT_Cap.Text = objDrive.mp_GetDriveName(sItem)
    End If
Else
    objDrive.p_Del_DriveLetters
    objDrive.p_GetDriveLetters("0") = sItem
    SetUSB_Info
End If
End Sub

Public Sub GetDriveCapacity()
Dim lp_Disk(0 To 2) As Double
Dim dPro            As Double
Dim objProg         As New cProgressBar
Dim iMultiplier     As Integer
Dim sFormat         As String
 
objDrive.mp_GetDiskSpace objDrive.p_GetDriveLetters(0)
lp_Disk(0) = objDrive.TotalSpace
lp_Disk(1) = objDrive.TotalFreeSpace
lp_Disk(2) = (objDrive.TotalSpace - objDrive.TotalFreeSpace)


With frmMain

    'wenn MB in Combo gewhlt Multiplier = 2 sprich: 1024^2 = Umrechnung in MB
    'wenn GB in Combo gewhlt Multiplier = 3 sprich: 1024^3 = Umrechnung in GB
    iMultiplier = .cmbSize.ItemData(.cmbSize.ListIndex)
    
    If .cmbSize.ListIndex = 0 Then
        sFormat = "##0.#0"
    Else
        sFormat = "##0.#00"
    End If
    
    .lblHDSize.Caption = Format(lp_Disk(0) / 1024 ^ iMultiplier, sFormat)
    .lblHDFree.Caption = Format(lp_Disk(1) / 1024 ^ iMultiplier, sFormat)
    .lblHDUsed.Caption = Format(lp_Disk(2) / 1024 ^ iMultiplier, sFormat)

    'Berechnung der prozentuallen Auslastung
    dPro = ((lp_Disk(2) / 1024 ^ iMultiplier) / (lp_Disk(0) / 1024 ^ iMultiplier)) * 100

    .lblHDUsedColor.BackColor = RGB(222, 0, 0)
    .lblHDFreeColor.BackColor = RGB(0, 222, 0)
    objProg.StartFarbe 100, 0, 0
    objProg.EndFarbe 200, 0, 0

    objProg.ShowProgress .Picture1, dPro, 0, 100, True
    Set objProg = Nothing
End With
End Sub

Public Sub SetUSB_Info()
   
GetDriveCapacity
With frmMain
    .lblLW = objDrive.p_GetDriveLetters(0)
    Dim sOpenPath As String
    sOpenPath = scol_Value("0")
    If mp_Check4FileExist(p_GetDriveLetters(0) & "USB.ini") Then
        If Left(sOpenPath, 1) = "\" Then
            sOpenPath = Right(sOpenPath, Len(sOpenPath) - 1)
        Else
            sOpenPath = sOpenPath
        End If
        
        objDrive.mp_StandardPfad = sOpenPath
        
        .txtOpenPath.Text = sOpenPath
    End If
    .cmdChoose.Enabled = True
    .txtDT_Cap.Text = objDrive.mp_GetDriveName(objDrive.p_GetDriveLetters("0"))
    .txtFAT.Text = objDrive.mp_FileSystem
    
    objTray.TrayIcon_Icon = LoadResPicture(ICON_USB_STICK_FOUND, vbResIcon)
    objTray.TrayIcon_Modify frmMain.Caption, objTray.TrayIcon_Icon
End With
End Sub
'####################################################
'#                  Properties                      #
'####################################################

'###################Laufwerkstypen##################
'Bezeichnung:   p_GetDT_Count
'Property   :   nur Ausgabe
'Funktion   :   ermittelt Anzahl der Elemente in mc_DriveCol_Type
Public Property Get p_GetDT_Count() As Long
On Error GoTo z
p_GetDT_Count = mc_DriveCol_Type.Count
Exit Property
z:
p_GetDT_Count = 0
End Property

'Bezeichnung:   p_GetDriveTyps
'Property   :   Ausgabe
'Funktion   :   gibt Laufwerkstypbezeichnung in mc_DriveCol_Type aus
Public Property Get p_GetDriveTyps(ByVal Key As String) As String
On Error GoTo z
p_GetDriveTyps = mc_DriveCol_Type(Key)
Exit Property
z:
p_GetDriveTyps = ""
End Property

'Bezeichnung:   p_GetDriveTyps
'Property   :   Eingabe
'Funktion   :   weist Laufwerkstypbezeichnung mc_DriveCol_Type zu
Public Property Let p_GetDriveTyps(ByVal Key As String, ByVal sNew As String)
mc_DriveCol_Type.Add sNew, Key
End Property

'Bezeichnung:   p_Del_DriveTyps
'Property   :   Eingabe
'Funktion   :   entfernt einen Eintrag aus mc_DriveCol_Type
Public Sub p_Del_DriveTyps()
Set mc_DriveCol_Type = New Collection
End Sub

'###############Laufwerksbuchstaben#################

'Bezeichnung:   p_GetDL_Count
'Property   :   nur Ausgabe
'Funktion   :   ermittelt Anzahl der Elemente in mc_DriveCol_Letter
Public Property Get p_GetDL_Count() As Long
On Error GoTo z
p_GetDL_Count = mc_DriveCol_Letter.Count
Exit Property
z:
p_GetDL_Count = 0
End Property

' Durchsucht einen Ordner nach Dateien
' Sollte der Ordner selbst nicht durchsucht werden knnen,
' gibt die Funktion 0 zurck. Sonst wird die Anzahl der Dateien zurckgegeben
Public Function GetAllFiles(ByVal Root As String, _
                            ByRef Field() As String, _
                            ByRef Index() As Integer, _
                            Optional DoRecursion As Boolean = False, _
                            Optional UsedField As Long = 0) As Long
    
    Dim File        As String
    Dim hFile       As Long
    Dim FD          As WIN32_FIND_DATA
    
    ' Evtl. Array vergrern?
    If (UsedField = UBound(Field)) Then
        ReDim Preserve Field(UBound(Field) + 100)
    End If
    
    DoEvents
    
    'Backslash ergnzen
    If Right(Root, 1) <> "\" Then Root = Root & "\"
    
    ' Die erste Datei suchen
    hFile = FindFirstFile(Root & "*.*", FD)
    
    ' Es konnte nichts gefunden werden
    If hFile = 0 Then
        GetAllFiles = 0
        Exit Function
    End If
    
    ' Fr jede Datei
    Do
        ' Den Dateinamen extrahieren
        File = Left(FD.cFileName, InStr(FD.cFileName, Chr(0)) - 1)
        
        ' Ist die Datei ein Verzeichnis?
        If (FD.dwFileAttributes And FILE_ATTRIBUTE_DIRECTORY) _
            = FILE_ATTRIBUTE_DIRECTORY Then
            
            ' . und .. ignorieren
            If (File <> ".") And (File <> "..") Then
                ' Unterordner auch durchsuchen?
                If DoRecursion Then
                    ' Ergebnis speichern
                    ' Verzeichnis: ">>" kann entfernt werden,
                    ' da nur zur Visualisierung
                    Field(UsedField) = Root & File
                    Index(UsedField) = GetAllFiles
                    
                    GetAllFiles = GetAllFiles + 1
                    UsedField = UsedField + 1
                    
                    ' Evtl. Array vergrern
                    If (UsedField = UBound(Field)) = 0 Then
                        ReDim Preserve Field(0 To UBound(Field) + 100)
                        ReDim Preserve Index(0 To UBound(Index) + 100)
                    End If
                    ' Unterordner rekursiv erfassen
                    GetAllFiles = GetAllFiles + GetAllFiles(Root & File, _
                        Field, Index, DoRecursion, UsedField)
                Else
                    
                    ' Ergebnis speichern
                    ' Verzeichnis: ">>" kann entfernt werden,
                    ' da nur zur Visualisierung
                    Field(UsedField) = Root & File
                    Index(UsedField) = GetAllFiles
                    
                    GetAllFiles = GetAllFiles + 1
                    UsedField = UsedField + 1
                    
                    ' Evtl. Array vergrern
                    If (UsedField = UBound(Field)) = 0 Then
                        ReDim Preserve Field(0 To UBound(Field) + 100)
                        ReDim Preserve Index(0 To UBound(Index) + 100)
                    End If
                End If
            End If
'wenn Dateien mitgesucht werden sollen,
'        Else
'
'            ' Passt das Suchmuster?
'            If (Such Like Right$(UCase$(File), Len(Such))) Or Such = "*" Then
'
'                ' Ergebnis speichern
'                ' Datei: "    " kann entfernt werden,
'                ' da nur zur Visualisierung
'                Field(UsedField) = "    " & Root & File
'                GetAllFiles = GetAllFiles + 1
'                UsedField = UsedField + 1
'
'                ' Evtl. Array vergrern
'                If (UsedField = UBound(Field)) Then
'                    ReDim Preserve Field(0 To UBound(Field) + 100)
'                End If
'            End If
        End If
    
    ' Nchste Datei suchen
    Loop While FindNextFile(hFile, FD)
    
    ' Suchhandle wieder freigeben - Suche beenden
    Call FindClose(hFile)
End Function

'Bezeichnung:   p_GetDriveLetters
'Property   :   Ausgabe
'Funktion   :   weist Laufwerksbuchstabe mc_DriveCol_Letter zu
Public Property Get p_GetDriveLetters(ByVal Key As String) As String
On Error GoTo z
p_GetDriveLetters = mc_DriveCol_Letter(Key)
Exit Property
z:
p_GetDriveLetters = ""
End Property

'Bezeichnung:   p_GetDriveLetters
'Property   :   Eingabe
'Funktion   :   gibt Laufwerksbuchstabe in mc_DriveCol_Letter aus
Public Property Let p_GetDriveLetters(ByVal Key As String, ByVal sNew As String)
If Right(sNew, 1) <> "\" Then sNew = sNew & "\"
mc_DriveCol_Letter.Add sNew, Key
End Property

'Bezeichnung:   p_Del_DriveLetters
'Property   :   Eingabe
'Funktion   :   entfernt einen Eintrag aus mc_DriveCol_Letter
Public Sub p_Del_DriveLetters()
Set mc_DriveCol_Letter = New Collection
End Sub

'###############Infos aus File auf USB Stick#################

'Bezeichnung:   p_SetUSBInfos
'Property   :   Eingabe
'Funktion   :   fgt einen Eintrag zu mc_USBFile hinzu
Public Property Let p_SetUSBInfos(ByVal Key As String, ByVal sNew As String)
mc_USBFile.Add sNew, Key
End Property

'Bezeichnung:   p_GetUSBInfos
'Property   :   Ausgabe
'Funktion   :   gibt einen Eintrag aus mc_USBFile zurck
Public Property Get p_GetUSBInfos(ByVal Key As String) As String
On Error GoTo z
p_GetUSBInfos = mc_USBFile.Item(Key)

Exit Property
z:
p_GetUSBInfos = ""
End Property


'Bezeichnung:   p_USBInfosCount
'Property   :   Ausgabe
'Funktion   :   ermittelt Anzahl der Elemente in mc_DriveCol_Letter
Public Property Get p_USBInfosCount() As Long
On Error GoTo z
p_USBInfosCount = mc_USBFile.Count

Exit Property
z:
p_USBInfosCount = 0
End Property

Private Sub Class_Initialize()
mp_bUse = True
End Sub

Private Sub Class_Terminate()
Set mc_USBFile = Nothing
Set mc_DriveCol_Letter = Nothing
Set mc_DriveCol_Type = Nothing
End Sub

Public Property Get mp_FileSystem() As String
mp_FileSystem = mp_FileS
End Property

Public Property Get mp_StandardPfad() As String
'existiert bergebener Pfad?
If mp_Check4FileExist(p_GetDriveLetters(0) & mp_Pfad) Then
    If mp_bUse Then mp_StandardPfad = mp_Pfad
Else
    'kein Pfad
    If Len(mp_Pfad) = 0 Then
        mp_StandardPfad = ""
    Else
        'Stammlaufwerk als Standardpfad gewhlt
        mp_bUse = False
        mp_StandardPfad = ""
    End If
End If
End Property

Public Property Let mp_StandardPfad(ByVal sNewValue As String)
    mp_Pfad = sNewValue
End Property
